diff --git a/TAGS b/TAGS
index 40e1640..c22cb0d 100644
--- a/TAGS
+++ b/TAGS
@@ -1145,66 +3320,69 @@ mod tests {tests217,7212
 mod prop_tests {prop_tests384,12404
     fn unique_cat_names() -> impl Strategy<Value = Vec<String>> {unique_cat_names389,12500
 
-src/view/layout.rs,4726
-pub fn synthetic_record_info(key: &CellKey) -> Option<(usize, String)> {synthetic_record_info9,242
-pub enum AxisEntry {AxisEntry21,739
-    GroupHeader {GroupHeader22,760
-    DataItem(Vec<String>),DataItem26,839
-pub struct GridLayout {GridLayout34,1187
-    pub row_cats: Vec<String>,row_cats35,1211
-    pub col_cats: Vec<String>,col_cats36,1242
-    pub page_coords: Vec<(String, String)>,page_coords37,1273
-    pub row_items: Vec<AxisEntry>,row_items38,1317
-    pub col_items: Vec<AxisEntry>,col_items39,1352
-    pub none_cats: Vec<String>,none_cats41,1457
-    pub records: Option<Rc<Vec<(CellKey, CellValue)>>>,records44,1610
-impl GridLayout {GridLayout47,1669
-    pub fn with_frozen_records(with_frozen_records50,1833
-    pub fn new(model: &Model, view: &View) -> Self {new70,2504
-    fn build_records_mode(build_records_mode128,4479
-    pub fn records_display(&self, row: usize, col: usize) -> Option<String> {records_display184,6393
-    pub fn prune_empty(&mut self, model: &Model) {prune_empty209,7362
-    pub fn is_records_mode(&self) -> bool {is_records_mode301,10722
-    pub fn row_count(&self) -> usize {row_count306,10858
-    pub fn col_count(&self) -> usize {col_count314,11086
-    pub fn row_label(&self, row: usize) -> String {row_label321,11257
-    pub fn col_label(&self, col: usize) -> String {col_label336,11641
-    pub fn resolve_display(&self, key: &CellKey) -> Option<String> {resolve_display353,12151
-    pub fn display_text(display_text367,12753
-    pub fn cell_key(&self, row: usize, col: usize) -> Option<CellKey> {cell_key388,13537
-    pub fn data_row_to_visual(&self, data_row: usize) -> Option<usize> {data_row_to_visual435,15049
-    pub fn data_col_to_visual(&self, data_col: usize) -> Option<usize> {data_col_to_visual449,15500
-    pub fn row_group_for(&self, data_row: usize) -> Option<(String, String)> {row_group_for464,16012
-    pub fn col_group_for(&self, data_col: usize) -> Option<(String, String)> {col_group_for481,16600
-fn expand_category(expand_category500,17249
-fn cross_product(model: &Model, view: &View, cats: &[String]) -> Vec<AxisEntry> {cross_product550,18870
-mod tests {tests568,19464
-    fn records_model() -> Model {records_model574,19646
-    fn prune_empty_removes_all_empty_columns_in_pivot_mode() {prune_empty_removes_all_empty_columns_in_pivot_mode599,20462
-    fn records_mode_activated_when_index_and_dim_on_axes() {records_mode_activated_when_index_and_dim_on_axes620,21304
-    fn records_mode_cell_key_returns_synthetic_for_all_columns() {records_mode_cell_key_returns_synthetic_for_all_columns631,21697
-    fn records_mode_resolve_display_returns_values() {records_mode_resolve_display_returns_values654,22680
-    fn synthetic_record_info_returns_none_for_pivot_keys() {synthetic_record_info_returns_none_for_pivot_keys681,23765
-    fn synthetic_record_info_extracts_index_and_dim() {synthetic_record_info_extracts_index_and_dim690,24064
-    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord700,24411
-    fn two_cat_model() -> Model {two_cat_model709,24632
-    fn row_and_col_counts_match_item_counts() {row_and_col_counts_match_item_counts723,25036
-    fn cell_key_encodes_correct_coordinates() {cell_key_encodes_correct_coordinates731,25311
-    fn cell_key_out_of_bounds_returns_none() {cell_key_out_of_bounds_returns_none740,25628
-    fn cell_key_includes_page_coords() {cell_key_includes_page_coords748,25888
-    fn cell_key_round_trips_through_model_evaluate() {cell_key_round_trips_through_model_evaluate764,26575
-    fn labels_join_with_slash_for_multi_cat_axis() {labels_join_with_slash_for_multi_cat_axis777,27035
-    fn row_count_excludes_group_headers() {row_count_excludes_group_headers792,27640
-    fn group_header_emitted_at_group_boundary() {group_header_emitted_at_group_boundary811,28321
-    fn collapsed_group_has_header_but_no_data_items() {collapsed_group_has_header_but_no_data_items838,29289
-    fn ungrouped_items_produce_no_headers() {ungrouped_items_produce_no_headers869,30497
-    fn cell_key_correct_with_grouped_items() {cell_key_correct_with_grouped_items887,30990
-    fn data_row_to_visual_skips_headers() {data_row_to_visual_skips_headers909,31782
-    fn data_col_to_visual_skips_headers() {data_col_to_visual_skips_headers928,32594
-    fn row_group_for_finds_enclosing_group() {row_group_for_finds_enclosing_group947,33370
-    fn row_group_for_returns_none_for_ungrouped() {row_group_for_returns_none_for_ungrouped970,34123
-    fn col_group_for_finds_enclosing_group() {col_group_for_finds_enclosing_group981,34540
-    fn col_group_for_returns_none_for_ungrouped() {col_group_for_returns_none_for_ungrouped1004,35310
+src/view/layout.rs,5045
+pub fn synthetic_record_info(key: &CellKey) -> Option<(usize, String)> {synthetic_record_info10,284
+pub enum AxisEntry {AxisEntry22,781
+    GroupHeader {GroupHeader23,802
+    DataItem(Vec<String>),DataItem27,881
+pub struct GridLayout {GridLayout35,1229
+    pub row_cats: Vec<String>,row_cats36,1253
+    pub col_cats: Vec<String>,col_cats37,1284
+    pub page_coords: Vec<(String, String)>,page_coords38,1315
+    pub row_items: Vec<AxisEntry>,row_items39,1359
+    pub col_items: Vec<AxisEntry>,col_items40,1394
+    pub none_cats: Vec<String>,none_cats42,1499
+    pub records: Option<Rc<Vec<(CellKey, CellValue)>>>,records45,1652
+impl GridLayout {GridLayout48,1711
+    pub fn with_frozen_records(with_frozen_records51,1875
+    pub fn new(model: &Model, view: &View) -> Self {new72,2530
+    fn build_records_mode(build_records_mode129,4478
+    pub fn records_display(&self, row: usize, col: usize) -> Option<String> {records_display186,6448
+    pub fn prune_empty(&mut self, model: &Model) {prune_empty211,7417
+    pub fn is_records_mode(&self) -> bool {is_records_mode303,10777
+    pub fn row_count(&self) -> usize {row_count308,10913
+    pub fn col_count(&self) -> usize {col_count316,11141
+    pub fn row_label(&self, row: usize) -> String {row_label323,11312
+    pub fn col_label(&self, col: usize) -> String {col_label338,11696
+    pub fn resolve_display(&self, key: &CellKey) -> Option<String> {resolve_display355,12206
+    pub fn display_text(display_text369,12808
+    pub fn cell_key(&self, row: usize, col: usize) -> Option<CellKey> {cell_key390,13592
+    pub fn data_row_to_visual(&self, data_row: usize) -> Option<usize> {data_row_to_visual437,15104
+    pub fn data_col_to_visual(&self, data_col: usize) -> Option<usize> {data_col_to_visual451,15555
+    pub fn row_group_for(&self, data_row: usize) -> Option<(String, String)> {row_group_for466,16067
+    pub fn col_group_for(&self, data_col: usize) -> Option<(String, String)> {col_group_for483,16655
+fn expand_category(expand_category502,17304
+fn cross_product(model: &Model, view: &View, cats: &[String]) -> Vec<AxisEntry> {cross_product552,18925
+mod tests {tests570,19519
+    fn records_model() -> Model {records_model576,19701
+    fn prune_empty_removes_all_empty_columns_in_pivot_mode() {prune_empty_removes_all_empty_columns_in_pivot_mode603,20637
+    fn records_mode_activated_when_index_and_dim_on_axes() {records_mode_activated_when_index_and_dim_on_axes624,21479
+    fn records_mode_cell_key_returns_synthetic_for_all_columns() {records_mode_cell_key_returns_synthetic_for_all_columns635,21872
+    fn records_mode_resolve_display_returns_values() {records_mode_resolve_display_returns_values658,22855
+    fn synthetic_record_info_returns_none_for_pivot_keys() {synthetic_record_info_returns_none_for_pivot_keys685,23940
+    fn synthetic_record_info_extracts_index_and_dim() {synthetic_record_info_extracts_index_and_dim694,24239
+    fn records_mode_includes_measure_in_dim_columns() {records_mode_includes_measure_in_dim_columns708,24795
+    fn records_mode_initial_layout_is_sorted() {records_mode_initial_layout_is_sorted736,25854
+    fn records_mode_new_record_appends_at_bottom() {records_mode_new_record_appends_at_bottom775,27437
+    fn coord(pairs: &[(&str, &str)]) -> CellKey {coord806,28817
+    fn two_cat_model() -> Model {two_cat_model815,29038
+    fn row_and_col_counts_match_item_counts() {row_and_col_counts_match_item_counts829,29442
+    fn cell_key_encodes_correct_coordinates() {cell_key_encodes_correct_coordinates837,29717
+    fn cell_key_out_of_bounds_returns_none() {cell_key_out_of_bounds_returns_none846,30034
+    fn cell_key_includes_page_coords() {cell_key_includes_page_coords854,30294
+    fn cell_key_round_trips_through_model_evaluate() {cell_key_round_trips_through_model_evaluate870,30981
+    fn labels_join_with_slash_for_multi_cat_axis() {labels_join_with_slash_for_multi_cat_axis883,31441
+    fn row_count_excludes_group_headers() {row_count_excludes_group_headers898,32046
+    fn group_header_emitted_at_group_boundary() {group_header_emitted_at_group_boundary917,32727
+    fn collapsed_group_has_header_but_no_data_items() {collapsed_group_has_header_but_no_data_items944,33695
+    fn ungrouped_items_produce_no_headers() {ungrouped_items_produce_no_headers975,34903
+    fn cell_key_correct_with_grouped_items() {cell_key_correct_with_grouped_items993,35396
+    fn data_row_to_visual_skips_headers() {data_row_to_visual_skips_headers1015,36188
+    fn data_col_to_visual_skips_headers() {data_col_to_visual_skips_headers1034,37000
+    fn row_group_for_finds_enclosing_group() {row_group_for_finds_enclosing_group1053,37776
+    fn row_group_for_returns_none_for_ungrouped() {row_group_for_returns_none_for_ungrouped1076,38529
+    fn col_group_for_finds_enclosing_group() {col_group_for_finds_enclosing_group1087,38946
+    fn col_group_for_returns_none_for_ungrouped() {col_group_for_returns_none_for_ungrouped1110,39716
 
 src/view/axis.rs,243
 pub enum Axis {Axis5,142
@@ -1278,7 +3456,7 @@ fn run_headless_commands(cmds: &[String], file: &Option<PathBuf>) -> Result<()>
 fn run_headless_script(script_path: &PathBuf, file: &Option<PathBuf>) -> Result<()> {run_headless_script363,10632
 fn get_initial_model(file_path: &Option<PathBuf>) -> Result<Model> {get_initial_model371,11110
 
-src/command/cmd/core.rs,4594
+src/command/cmd/core.rs,4869
 pub struct CmdContext<'a> {CmdContext13,328
     pub model: &'a Model,model14,356
     pub layout: &'a GridLayout,layout15,382
@@ -1299,97 +3477,105 @@ pub struct CmdContext<'a> {CmdContext13,328
     pub view_panel_cursor: usize,view_panel_cursor31,868
     pub tile_cat_idx: usize,tile_cat_idx33,958
     pub buffers: &'a HashMap<String, String>,buffers35,1014
-    pub view_back_stack: &'a [String],view_back_stack37,1116
-    pub view_forward_stack: &'a [String],view_forward_stack38,1155
-    pub display_value: String,display_value40,1281
-    pub visible_rows: usize,visible_rows42,1384
-    pub visible_cols: usize,visible_cols43,1413
-    pub expanded_cats: &'a std::collections::HashSet<String>,expanded_cats45,1488
-    pub key_code: KeyCode,key_code47,1594
-impl<'a> CmdContext<'a> {CmdContext50,1624
-    pub fn cell_key(&self) -> Option<CellKey> {cell_key51,1650
-    pub fn row_count(&self) -> usize {row_count54,1767
-    pub fn col_count(&self) -> usize {col_count57,1844
-    pub fn none_cats(&self) -> &[String] {none_cats60,1921
-impl<'a> CmdContext<'a> {CmdContext65,2004
-    pub fn cat_tree_entry(&self) -> Option<crate::ui::cat_tree::CatTreeEntry> {cat_tree_entry67,2099
-    pub fn cat_at_cursor(&self) -> Option<String> {cat_at_cursor74,2430
-    pub fn cat_tree_len(&self) -> usize {cat_tree_len79,2607
-pub trait Cmd: Debug + Send + Sync {Cmd85,2793
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>>;execute86,2830
-    fn name(&self) -> &'static str;name90,3046
-pub type ParseFn = fn(&[String]) -> Result<Box<dyn Cmd>, String>;ParseFn94,3158
-pub type InteractiveFn = fn(&[String], &CmdContext) -> Result<Box<dyn Cmd>, String>;InteractiveFn100,3497
-type BoxParseFn = Box<dyn Fn(&[String]) -> Result<Box<dyn Cmd>, String>>;BoxParseFn102,3583
-type BoxInteractiveFn = Box<dyn Fn(&[String], &CmdContext) -> Result<Box<dyn Cmd>, String>>;BoxInteractiveFn103,3657
-struct CmdEntry {CmdEntry106,3827
-    name: &'static str,name107,3845
-    parse: BoxParseFn,parse108,3869
-    interactive: BoxInteractiveFn,interactive109,3892
-pub struct CmdRegistry {CmdRegistry114,4027
-    entries: Vec<CmdEntry>,entries115,4052
-    aliases: Vec<(&'static str, &'static str)>,aliases116,4080
-impl CmdRegistry {CmdRegistry119,4131
-    pub fn new() -> Self {new120,4150
-    pub fn alias(&mut self, short: &'static str, canonical: &'static str) {alias128,4348
-    fn resolve<'a>(&'a self, name: &'a str) -> &'a str {resolve133,4534
-    pub fn register(&mut self, prototype: &dyn Cmd, parse: ParseFn, interactive: InteractiveFn) register144,4897
-    pub fn register_pure(&mut self, prototype: &dyn Cmd, parse: ParseFn) {register_pure155,5368
-    pub fn register_nullary(&mut self, f: fn() -> Box<dyn Cmd>) {register_nullary171,5949
-    pub fn parse(&self, name: &str, args: &[String]) -> Result<Box<dyn Cmd>, String> {parse181,6290
-    pub fn interactive(interactive194,6812
-    pub fn names(&self) -> impl Iterator<Item = &'static str> + '_ {names210,7220
-pub(super) struct NamedCmd(pub(super) &'static str);NamedCmd218,7484
-impl Cmd for NamedCmd {NamedCmd219,7537
-    fn name(&self) -> &'static str {name220,7561
-    fn execute(&self, _: &CmdContext) -> Vec<Box<dyn Effect>> {execute223,7619
-pub(super) fn require_args(word: &str, args: &[String], n: usize) -> Result<(), String> {require_args228,7707
-pub(super) fn parse_cell_key_from_args(args: &[String]) -> crate::model::cell::CellKey {parse_cell_key_from_args240,8019
-pub(super) fn read_buffer(ctx: &CmdContext, name: &str) -> String {read_buffer252,8437
-pub(super) fn parse_panel(s: &str) -> Result<Panel, String> {parse_panel260,8649
-pub(super) fn parse_axis(s: &str) -> Result<Axis, String> {parse_axis269,8910
-mod tests {tests280,9232
-    fn parse_axis_recognizes_all_variants() {parse_axis_recognizes_all_variants284,9275
-    fn parse_axis_rejects_unknown() {parse_axis_rejects_unknown294,9609
+    pub view_back_stack: &'a [crate::ui::app::ViewFrame],view_back_stack37,1116
+    pub view_forward_stack: &'a [crate::ui::app::ViewFrame],view_forward_stack38,1174
+    pub has_drill_state: bool,has_drill_state40,1299
+    pub display_value: String,display_value42,1414
+    pub visible_rows: usize,visible_rows44,1517
+    pub visible_cols: usize,visible_cols45,1546
+    pub expanded_cats: &'a std::collections::HashSet<String>,expanded_cats47,1621
+    pub key_code: KeyCode,key_code49,1727
+impl<'a> CmdContext<'a> {CmdContext52,1757
+    pub fn is_records_mode(&self) -> bool {is_records_mode54,1853
+    pub fn cell_key(&self) -> Option<CellKey> {cell_key58,1942
+    pub fn synthetic_record_at_cursor(&self) -> Option<(usize, String)> {synthetic_record_at_cursor63,2136
+    pub fn row_count(&self) -> usize {row_count69,2321
+    pub fn col_count(&self) -> usize {col_count72,2398
+    pub fn none_cats(&self) -> &[String] {none_cats75,2475
+impl<'a> CmdContext<'a> {CmdContext80,2558
+    pub fn cat_tree_entry(&self) -> Option<crate::ui::cat_tree::CatTreeEntry> {cat_tree_entry82,2653
+    pub fn cat_at_cursor(&self) -> Option<String> {cat_at_cursor89,2984
+    pub fn cat_tree_len(&self) -> usize {cat_tree_len94,3161
+pub trait Cmd: Debug + Send + Sync {Cmd100,3347
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>>;execute101,3384
+    fn name(&self) -> &'static str;name105,3600
+pub type ParseFn = fn(&[String]) -> Result<Box<dyn Cmd>, String>;ParseFn109,3712
+pub type InteractiveFn = fn(&[String], &CmdContext) -> Result<Box<dyn Cmd>, String>;InteractiveFn115,4051
+type BoxParseFn = Box<dyn Fn(&[String]) -> Result<Box<dyn Cmd>, String>>;BoxParseFn117,4137
+type BoxInteractiveFn = Box<dyn Fn(&[String], &CmdContext) -> Result<Box<dyn Cmd>, String>>;BoxInteractiveFn118,4211
+struct CmdEntry {CmdEntry121,4381
+    name: &'static str,name122,4399
+    parse: BoxParseFn,parse123,4423
+    interactive: BoxInteractiveFn,interactive124,4446
+pub struct CmdRegistry {CmdRegistry129,4581
+    entries: Vec<CmdEntry>,entries130,4606
+    aliases: Vec<(&'static str, &'static str)>,aliases131,4634
+impl CmdRegistry {CmdRegistry134,4685
+    pub fn new() -> Self {new135,4704
+    pub fn alias(&mut self, short: &'static str, canonical: &'static str) {alias143,4902
+    fn resolve<'a>(&'a self, name: &'a str) -> &'a str {resolve148,5088
+    pub fn register(&mut self, prototype: &dyn Cmd, parse: ParseFn, interactive: InteractiveFn) register159,5451
+    pub fn register_pure(&mut self, prototype: &dyn Cmd, parse: ParseFn) {register_pure170,5922
+    pub fn register_nullary(&mut self, f: fn() -> Box<dyn Cmd>) {register_nullary186,6503
+    pub fn parse(&self, name: &str, args: &[String]) -> Result<Box<dyn Cmd>, String> {parse196,6844
+    pub fn interactive(interactive209,7366
+    pub fn names(&self) -> impl Iterator<Item = &'static str> + '_ {names225,7774
+pub(super) struct NamedCmd(pub(super) &'static str);NamedCmd233,8038
+impl Cmd for NamedCmd {NamedCmd234,8091
+    fn name(&self) -> &'static str {name235,8115
+    fn execute(&self, _: &CmdContext) -> Vec<Box<dyn Effect>> {execute238,8173
+pub(super) fn require_args(word: &str, args: &[String], n: usize) -> Result<(), String> {require_args243,8261
+pub(super) fn parse_cell_key_from_args(args: &[String]) -> crate::model::cell::CellKey {parse_cell_key_from_args255,8573
+pub(super) fn read_buffer(ctx: &CmdContext, name: &str) -> String {read_buffer267,8991
+pub(super) fn parse_panel(s: &str) -> Result<Panel, String> {parse_panel275,9203
+pub(super) fn parse_axis(s: &str) -> Result<Axis, String> {parse_axis284,9464
+mod tests {tests295,9786
+    fn parse_axis_recognizes_all_variants() {parse_axis_recognizes_all_variants299,9829
+    fn parse_axis_rejects_unknown() {parse_axis_rejects_unknown309,10163
 
-src/command/cmd/commit.rs,2493
-mod tests {tests9,235
-    fn commit_formula_with_categories_adds_formula() {commit_formula_with_categories_adds_formula17,389
-    fn commit_formula_without_regular_categories_targets_measure() {commit_formula_without_regular_categories_targets_measure40,1257
-    fn commit_category_add_with_name_produces_add_effect() {commit_category_add_with_name_produces_add_effect61,1996
-    fn commit_category_add_with_empty_buffer_returns_to_panel() {commit_category_add_with_empty_buffer_returns_to_panel78,2582
-    fn commit_item_add_with_name_produces_add_item() {commit_item_add_with_name_produces_add_item95,3181
-    fn commit_item_add_outside_item_add_mode_returns_empty() {commit_item_add_outside_item_add_mode_returns_empty111,3813
-    fn commit_export_produces_export_and_normal_mode() {commit_export_produces_export_and_normal_mode121,4136
-fn commit_cell_value(key: &CellKey, value: &str, effects: &mut Vec<Box<dyn Effect>>) {commit_cell_value141,5058
-pub enum AdvanceDir {AdvanceDir165,5992
-    Down,Down167,6084
-    Right,Right169,6143
-pub struct CommitAndAdvance {CommitAndAdvance175,6324
-    pub key: CellKey,key176,6354
-    pub value: String,value177,6376
-    pub advance: AdvanceDir,advance178,6399
-    pub cursor: CursorState,cursor179,6428
-impl Cmd for CommitAndAdvance {CommitAndAdvance181,6459
-    fn name(&self) -> &'static str {name182,6491
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute188,6686
-pub struct CommitFormula;CommitFormula218,7766
-impl Cmd for CommitFormula {CommitFormula219,7792
-    fn name(&self) -> &'static str {name220,7821
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute223,7889
-fn commit_add_from_buffer(commit_add_from_buffer242,8782
-pub struct CommitCategoryAdd;CommitCategoryAdd265,9489
-impl Cmd for CommitCategoryAdd {CommitCategoryAdd266,9519
-    fn name(&self) -> &'static str {name267,9552
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute270,9625
-pub struct CommitItemAdd;CommitItemAdd282,10002
-impl Cmd for CommitItemAdd {CommitItemAdd283,10028
-    fn name(&self) -> &'static str {name284,10057
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute287,10126
-pub struct CommitExport;CommitExport309,10747
-impl Cmd for CommitExport {CommitExport310,10772
-    fn name(&self) -> &'static str {name311,10800
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute314,10867
+src/command/cmd/commit.rs,2939
+mod tests {tests10,266
+    fn commit_formula_with_categories_adds_formula() {commit_formula_with_categories_adds_formula18,420
+    fn commit_formula_without_regular_categories_targets_measure() {commit_formula_without_regular_categories_targets_measure41,1288
+    fn commit_category_add_with_name_produces_add_effect() {commit_category_add_with_name_produces_add_effect62,2027
+    fn commit_category_add_with_empty_buffer_returns_to_panel() {commit_category_add_with_empty_buffer_returns_to_panel79,2613
+    fn commit_item_add_with_name_produces_add_item() {commit_item_add_with_name_produces_add_item96,3212
+    fn commit_item_add_outside_item_add_mode_returns_empty() {commit_item_add_outside_item_add_mode_returns_empty112,3844
+    fn commit_and_advance_threads_edit_mode_to_enter_edit_at_cursor() {commit_and_advance_threads_edit_mode_to_enter_edit_at_cursor125,4390
+    fn commit_export_produces_export_and_normal_mode() {commit_export_produces_export_and_normal_mode151,5415
+fn commit_regular_cell_value(key: &CellKey, value: &str, effects: &mut Vec<Box<dyn Effect>>) {commit_regular_cell_value172,6378
+fn stage_drill_edit(record_idx: usize, col_name: String, value: &str) -> Box<dyn Effect> {stage_drill_edit187,6974
+fn commit_plain_records_edit(commit_plain_records_edit196,7273
+fn commit_cell_value(commit_cell_value237,8302
+pub enum AdvanceDir {AdvanceDir257,8888
+    Down,Down259,8980
+    Right,Right261,9039
+pub struct CommitAndAdvance {CommitAndAdvance272,9482
+    pub key: CellKey,key273,9512
+    pub value: String,value274,9534
+    pub advance: AdvanceDir,advance275,9557
+    pub cursor: CursorState,cursor276,9586
+    pub edit_mode: AppMode,edit_mode277,9615
+impl Cmd for CommitAndAdvance {CommitAndAdvance279,9645
+    fn name(&self) -> &'static str {name280,9677
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute286,9872
+pub struct CommitFormula;CommitFormula334,11770
+impl Cmd for CommitFormula {CommitFormula335,11796
+    fn name(&self) -> &'static str {name336,11825
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute339,11893
+fn commit_add_from_buffer(commit_add_from_buffer359,12710
+pub struct CommitCategoryAdd;CommitCategoryAdd382,13417
+impl Cmd for CommitCategoryAdd {CommitCategoryAdd383,13447
+    fn name(&self) -> &'static str {name384,13480
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute387,13553
+pub struct CommitItemAdd;CommitItemAdd399,13930
+impl Cmd for CommitItemAdd {CommitItemAdd400,13956
+    fn name(&self) -> &'static str {name401,13985
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute404,14054
+pub struct CommitExport;CommitExport426,14675
+impl Cmd for CommitExport {CommitExport427,14700
+    fn name(&self) -> &'static str {name428,14728
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute431,14795
 
 src/command/cmd/cell.rs,1886
 mod tests {tests6,90
@@ -1423,9 +3609,10 @@ impl Cmd for SaveCmd {SaveCmd191,5938
     fn name(&self) -> &'static str {name192,5961
     fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute195,6019
 
-src/command/cmd/registry.rs,113
-pub fn default_registry() -> CmdRegistry {default_registry19,459
-    macro_rules! reg_jump {reg_jump105,4345
+src/command/cmd/registry.rs,193
+fn parse_mode_name(s: &str) -> Result<AppMode, String> {parse_mode_name7,208
+pub fn default_registry() -> CmdRegistry {default_registry40,1375
+    macro_rules! reg_jump {reg_jump126,5261
 
 src/command/cmd/effect_cmds.rs,518
 mod tests {tests8,162
@@ -1455,46 +3642,46 @@ impl Cmd for TileAxisOp {TileAxisOp120,3709
     fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute128,3904
 
 src/command/cmd/grid.rs,2719
-mod tests {tests8,153
-    fn toggle_group_under_cursor_returns_empty_without_groups() {toggle_group_under_cursor_returns_empty_without_groups13,242
-    fn law_toggle_group_involution() {law_toggle_group_involution24,614
-    fn view_forward_with_empty_stack_shows_status() {view_forward_with_empty_stack_shows_status36,1071
-    fn view_back_with_empty_stack_shows_status() {view_back_with_empty_stack_shows_status51,1554
-    fn view_forward_with_stack_produces_effect() {view_forward_with_stack_produces_effect66,2036
-    fn view_back_with_stack_produces_apply_and_back() {view_back_with_stack_produces_apply_and_back83,2610
-    fn toggle_prune_empty_produces_toggle_and_dirty() {toggle_prune_empty_produces_toggle_and_dirty102,3318
-    fn drill_into_formula_cell_returns_data_records() {drill_into_formula_cell_returns_data_records120,4053
-pub struct ToggleGroupAtCursor {ToggleGroupAtCursor171,5975
-    pub is_row: bool,is_row172,6008
-impl Cmd for ToggleGroupAtCursor {ToggleGroupAtCursor174,6032
-    fn name(&self) -> &'static str {name175,6067
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute182,6246
-pub struct HideSelectedRowItem;HideSelectedRowItem203,6803
-impl Cmd for HideSelectedRowItem {HideSelectedRowItem204,6835
-    fn name(&self) -> &'static str {name205,6870
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute208,6946
-pub struct ViewNavigate {ViewNavigate241,7823
-    pub forward: bool,forward242,7849
-impl Cmd for ViewNavigate {ViewNavigate244,7874
-    fn name(&self) -> &'static str {name245,7902
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute252,8049
-pub struct DrillIntoCell {DrillIntoCell276,8878
-    pub key: crate::model::cell::CellKey,key277,8905
-impl Cmd for DrillIntoCell {DrillIntoCell279,8949
-    fn name(&self) -> &'static str {name280,8978
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute283,9047
-pub struct TogglePruneEmpty;TogglePruneEmpty373,12481
-impl Cmd for TogglePruneEmpty {TogglePruneEmpty374,12510
-    fn name(&self) -> &'static str {name375,12542
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute378,12614
-pub struct ToggleRecordsMode;ToggleRecordsMode395,13218
-impl Cmd for ToggleRecordsMode {ToggleRecordsMode396,13248
-    fn name(&self) -> &'static str {name397,13281
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute400,13354
-pub struct AddRecordRow;AddRecordRow440,14897
-impl Cmd for AddRecordRow {AddRecordRow441,14922
-    fn name(&self) -> &'static str {name442,14950
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute445,15018
+mod tests {tests9,182
+    fn toggle_group_under_cursor_returns_empty_without_groups() {toggle_group_under_cursor_returns_empty_without_groups14,271
+    fn law_toggle_group_involution() {law_toggle_group_involution25,643
+    fn view_forward_with_empty_stack_shows_status() {view_forward_with_empty_stack_shows_status37,1100
+    fn view_back_with_empty_stack_shows_status() {view_back_with_empty_stack_shows_status52,1583
+    fn view_forward_with_stack_produces_effect() {view_forward_with_stack_produces_effect67,2065
+    fn view_back_with_stack_produces_apply_and_back() {view_back_with_stack_produces_apply_and_back87,2752
+    fn toggle_prune_empty_produces_toggle_and_dirty() {toggle_prune_empty_produces_toggle_and_dirty109,3573
+    fn drill_into_formula_cell_returns_data_records() {drill_into_formula_cell_returns_data_records127,4308
+pub struct ToggleGroupAtCursor {ToggleGroupAtCursor178,6230
+    pub is_row: bool,is_row179,6263
+impl Cmd for ToggleGroupAtCursor {ToggleGroupAtCursor181,6287
+    fn name(&self) -> &'static str {name182,6322
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute189,6501
+pub struct HideSelectedRowItem;HideSelectedRowItem210,7058
+impl Cmd for HideSelectedRowItem {HideSelectedRowItem211,7090
+    fn name(&self) -> &'static str {name212,7125
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute215,7201
+pub struct ViewNavigate {ViewNavigate248,8078
+    pub forward: bool,forward249,8104
+impl Cmd for ViewNavigate {ViewNavigate251,8129
+    fn name(&self) -> &'static str {name252,8157
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute259,8304
+pub struct DrillIntoCell {DrillIntoCell283,9133
+    pub key: crate::model::cell::CellKey,key284,9160
+impl Cmd for DrillIntoCell {DrillIntoCell286,9204
+    fn name(&self) -> &'static str {name287,9233
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute290,9302
+pub struct TogglePruneEmpty;TogglePruneEmpty380,12736
+impl Cmd for TogglePruneEmpty {TogglePruneEmpty381,12765
+    fn name(&self) -> &'static str {name382,12797
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute385,12869
+pub struct ToggleRecordsMode;ToggleRecordsMode402,13473
+impl Cmd for ToggleRecordsMode {ToggleRecordsMode403,13503
+    fn name(&self) -> &'static str {name404,13536
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute407,13609
+pub struct AddRecordRow;AddRecordRow450,15270
+impl Cmd for AddRecordRow {AddRecordRow451,15295
+    fn name(&self) -> &'static str {name452,15323
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute455,15391
 
 src/command/cmd/text_buffer.rs,1949
 mod tests {tests9,164
@@ -1547,12 +3734,12 @@ pub(super) mod test_helpers {test_helpers19,341
     pub static EMPTY_EXPANDED: std::sync::LazyLock<std::collections::HashSet<String>> =EMPTY_EXPANDED36,830
     pub fn make_layout(model: &Model) -> GridLayout {make_layout39,985
     pub fn make_ctx<'a>(make_ctx43,1098
-    pub fn two_cat_model() -> Model {two_cat_model86,2450
-    pub fn three_cat_model_with_page() -> Model {three_cat_model_with_page97,2864
-    pub fn effects_debug(effects: &[Box<dyn Effect>]) -> String {effects_debug114,3613
-    pub fn make_registry() -> CmdRegistry {make_registry118,3719
+    pub fn two_cat_model() -> Model {two_cat_model87,2486
+    pub fn three_cat_model_with_page() -> Model {three_cat_model_with_page98,2900
+    pub fn effects_debug(effects: &[Box<dyn Effect>]) -> String {effects_debug115,3649
+    pub fn make_registry() -> CmdRegistry {make_registry119,3755
 
-src/command/cmd/navigation.rs,2755
+src/command/cmd/navigation.rs,2756
 pub struct CursorState {CursorState12,526
     pub row: usize,row13,551
     pub col: usize,col14,571
